using System;

namespace Smdn.Protocols.Imap4 {
  public class ImapNamespace {
    public class NamespaceGroup {
      public string Namespace { 
        get { return @namespace; }
      }

      public string Delimiter {
        get { return delimiter; }
      }
      
      public string Extension {
        get { return extension; }
      }

      internal NamespaceGroup()
        : this(string.Empty, string.Empty, string.Empty)
      {
      }

      internal NamespaceGroup(string @namespace, string delimiter, string extension)
      {
        this.@namespace = @namespace;
        this.delimiter = delimiter;
        this.extension = extension;
      }

      public override string ToString()
      {
        return string.Format("{{Namespace={0}, Delimiter={1}, Extension={2}}}",
                             @namespace,
                             delimiter,
                             extension);
      }

      private readonly string @namespace;
      private readonly string delimiter;
      private readonly string extension;
    }

    public NamespaceGroup Personal {
      get { return personal; }
    }

    public NamespaceGroup Other {
      get { return other; }
    }

    public NamespaceGroup Shared {
      get { return shared; }
    }

    internal ImapNamespace()
      : this(new NamespaceGroup(), new NamespaceGroup(), new NamespaceGroup()) 
    {
    }

    internal ImapNamespace(NamespaceGroup personal, NamespaceGroup other, NamespaceGroup shared)
    {
      this.personal = personal;
      this.other = other;
      this.shared = shared;
    }

    public override string ToString()
    {
      return string.Format("{{Personal={0}, Other={1}, Shared={2}}}",
                           personal,
                           other,
                           shared);
    }

    private readonly NamespaceGroup personal;
    private readonly NamespaceGroup other;
    private readonly NamespaceGroup shared;
  }
}
