using System;

namespace Smdn.Protocols.Pop3 {
  internal static class PopConverter
  {
    public static PopAuthenticationType ToAuthType(string authType)
    {
      switch (authType.ToUpper()) {
        case "+APOP":
          return PopAuthenticationType.Apop;
        case "PLAIN":
          return PopAuthenticationType.Plain;
        case "LOGIN":
          return PopAuthenticationType.Login;
        case "SCRAM-MD5":
          return PopAuthenticationType.ScramMd5;
        case "CRAM-MD5":
          return PopAuthenticationType.CramMd5;
        case "KERBEROS_V4":
          return PopAuthenticationType.KerberosV4;
        case "*":
          return PopAuthenticationType.Any;
        default:
          throw new NotSupportedException("unsupported authentication type");
      }
    }

    public static string ToString(PopAuthenticationType authType)
    {
      switch (authType) {
        case PopAuthenticationType.Apop:
          return "+APOP";
        case PopAuthenticationType.Plain:
          return "PLAIN";
        case PopAuthenticationType.Login:
          return "LOGIN";
        case PopAuthenticationType.ScramMd5:
          return "SCRAM-MD5";
        case PopAuthenticationType.CramMd5:
          return "CRAM-MD5";
        case PopAuthenticationType.KerberosV4:
          return "KERBEROS_V4";
        case PopAuthenticationType.Any:
          return "*";
        case PopAuthenticationType.None:
          return string.Empty;
        default:
          throw new ArgumentOutOfRangeException();
      }
    }
  }
}
