using System;

using Smdn.Protocols.Pop3.Protocol;

namespace Smdn.Protocols.Pop3.Transaction.Transactions {
  internal class NoOpTransaction : TransactionBase {
    // ProcessNoOp
    //   ->WaitForNoOp
    // WaitForNoOp
    //   x Conclude

    public NoOpTransaction(PopConnection connection, PopRequest request)
      : base(connection, request)
    {
    }

    protected override ProcessTransactionDelegate Reset()
    {
      return ProcessNoOp;
    }

    private void ProcessNoOp()
    {
      Send("NOOP");

      Transit(WaitForNoOp);
    }

    private void WaitForNoOp()
    {
      PopProtocolResponse response;

      if (!Receive(out response))
        return;

      if (response is PopStatusResponse) {
        var status = response as PopStatusResponse;

        if (status.Status == PopProtocolStatus.Positive) {
          Conclude(new PopResponse(PopTransactionStatus.Ok, "no operation"));
        }
        else {
          ConcludeError(status);
        }
      }
    }
  }
}
